#include <stdlib.h>
#include <iostream.h>

#include "index.h"
#include "randnum.h"
#include "element.h"
#include "grid.h"

/*
 * recover parameters from command line
 */
bool processCommandLine(int argc, char** argv, int& ncols, int& nrows, int& ntimesteps)
{
  if (argc < 4) {
    return false;
  }

  ncols = atoi(argv[1]);
  nrows = atoi(argv[2]);
  ntimesteps = atoi(argv[3]);

  return true;
}

/*
 * entry point
 */
int main(int argc, char* argv[])
{
  int ncols, nrows, ntimeSteps;

  ncols = nrows = -1;

  // find size of grid
  if (!processCommandLine(argc, argv, ncols, nrows, ntimeSteps)) {
    cerr << "usage: " << argv[0] << " <number columns> <number rows> <number timesteps>\n";
    exit(-1);
  }

  // check the input
  if (ncols < 1 || nrows < 1) {
    cerr << argv[0] << ": numbers of columns and rows must be positive\n";
    exit(-1);
  }

  // create the grid object (and generate the 2D array of elements within it)
  Grid grid = Grid(ncols, nrows);

  // initialise elements with random (u,v) field
  grid.init();

  int count = 1;

  // run thru time steps
  while (count <= ntimeSteps) {
    cout << "Step " << count << "\n";
    cout.flush();
    grid.step();
    grid.output(count);
    count++;
  }

  return 0;
}

/*
 * E N D  O F  F I L E
 */
